function img = Lab2XYZ(img)

exact = 1;
                                                                                
% Reformat image for linear color transformations
[height,width,Ncolors] = size(img);
img = permute(img,[3,1,2]);
img = reshape(img,Ncolors,height*width);

% Invert Lab transformation
if exact==1
  TLab = [ 0, 116, 0; 500, -500, 0; 0, 200, -200];
  img = TLab^(-1)*(img+[16;0;0]*ones(1,width*height));
else
  TLab = [ 0, 100, 0; 500, -500, 0; 0, 200, -200];
  img = TLab^(-1)*img;
end

% Remove nonlinear function
if exact==1
  img = max( 3*(24/116)^2*(img-(16/116)),img.^3 );
else
  img = img.^3;
end

% Chromaticities (x,y,z) - Rec. 709 Primary System
R709=[0.64 0.33 0.03]';
G709=[0.30 0.60 0.10]';
B709=[0.15 0.06 0.79]';
                                                                                
% D65 white point with Y=1.0
wpD65=[0.3127 0.3290 0.3583]';
wpD65=wpD65/wpD65(2);
                                                                                
% Multiply by Xo,Yo,Zo
img = diag(wpD65)*img;

% Put image back in standard format
img = reshape(img,Ncolors,height,width);
img = ipermute(img,[3,1,2]);

