function LinLabDeltaE = LinLabMetric(img1,img2,distance,dpi)

% Convert images to filtered YCxCz format and filter
img1 = XYZ2YCxCz(sRGB2XYZ(img1));
img1 = Filter1(img1,distance,dpi);

img2 = XYZ2YCxCz(sRGB2XYZ(img2));
img2 = Filter1(img2,distance,dpi);

% Compute YCxCzLab Delta E at each pixel
%difference = Filter1(img1-img2,distance,dpi);
difference = img1-img2;
difference = difference.^2;
difference = sum(difference,3);

figure
image(uint8(round(0.5*sqrt(difference))))
colormap(gray(256));
axis('image');
title('Linear Lab Delta E Image (1992 paper)')

% Compute average YCxCz squared error over image
border = 10;
[height,width] = size(difference);
truncatedimg = difference(border:(height-border),border:(width-border));
LinLabDeltaE = sqrt(mean(mean(truncatedimg)));

