% This program demonstrates some programs for computing
% Fidelity metrics using the YCxCz color coordinate system

% This is a preliminary version, SO IT MAY HAVE BUGES!!!!!!!!!!!!!!!!!

% The two metrics are described in the papers:
%   T. J. Flohr, B. W. Kolpatzik, R. Balasubramanian, D. A. Carrara, C. A. 
%   Bouman, and J. P. Allebach, ``Model Based Color Image Quantization,'' 
%   {\em Proc. of SPIE/IS\&T Conf. on Human Vision, Visual Processing, and 
%   Digital Display}, vol. 1993, pp. 270-281, San Jose, CA, January 31-Feb. 4, 1993.
% and 
%   B. Kolpatzik and C. Bouman, 
%   ``Optimized Error Diffusion for Image Display,''
%   {\em Journal of Electronic Imaging}, vol. 1, no. 3, pp. 277-292, July 1992.
% and 
%   B. Kolpatzik and C. Bouman, 
%   ``Optimal Universal Color Palette Design for Error Diffusion,'' 
%   {\em Journal of Electronic Imaging}, vol. 4, no. 2, pp. 131-143, April 1995.


% This program assumes that the input images
% are in sRGB format.

close all
                                                                                
% Distance in inches
distance = 10;
                                                                                
% Dots per inch
dpi = 100;
                                                                                
% Read images
img1Name = '../images/img03.tif';
img2Name = '../images/imgblur.tif';
img1 = double(imread(img1Name));
img2 = double(imread(img2Name));
                                                                                
figure
image(uint8(round(img1)))
axis('image')
title('Image 1')
                                                                                
figure
image(uint8(round(img2)))
axis('image')
title('Image 2')

% This program computes Linear Lab fidelity metric from 1992 paper
linLabDeltaE = LinLabMetric(img1,img2,distance,dpi)

% This program computes YCxCzLab fidelity metric from 1995 paper
YCxCzLabDeltaE = YCxCzLabMetric(img1,img2,distance,dpi)

