function img = XYZ2Lab(img)

exact = 1;

% Reformat image for linear color transformations
[height,width,Ncolors] = size(img);
img = permute(img,[3,1,2]);
img = reshape(img,Ncolors,height*width);

% Make sure that XYZ values are positive
img = max(img,0);

% D65 white point with Y=1.0
wpD65=[0.3127 0.3290 0.3583]';
wpD65=wpD65/wpD65(2);
                                                                                
% Divide by Xo,Yo,Zo
img = diag(1./wpD65)*img;

% Apply nonlinear function
if exact==1
  img = min( (1/3)*(116/24)^2*img+(16/116),img.^(1/3) );
else
  img = img.^(1/3);
end

% Apply standard Lab transformation
if exact==1
  TLab = [ 0, 116, 0; 500, -500, 0; 0, 200, -200];
  img = TLab*img - [16;0;0]*ones(1,height*width);
else
  TLab = [ 0, 100, 0; 500, -500, 0; 0, 200, -200];
  img = TLab*img;
end

% Put image back in standard format
img = reshape(img,Ncolors,height,width);
img = ipermute(img,[3,1,2]);

