function YCxCzLabDeltaE = YCxCzLabMetric(img1,img2,distance,dpi)

% Convert images to filtered YCxCz format
img1 = XYZ2YCxCz(sRGB2XYZ(img1));
img1 = Filter2(img1,distance,dpi);
img1 = XYZ2Lab(YCxCz2XYZ(img1));

img2 = XYZ2YCxCz(sRGB2XYZ(img2));
img2 = Filter2(img2,distance,dpi);
img2 = XYZ2Lab(YCxCz2XYZ(img2));

% Compute YCxCzLab Delta E at each pixel
difference = (img1-img2).^2;
difference = sum(difference,3);

figure
image(uint8(round(50*sqrt(difference))))
colormap(gray(256));
axis('image');
title('YCxCzLab Delta E Image (1995 paper)')

% Compute average YCxCzLab Delta E over image
border = 10;
[height,width] = size(difference);
truncatedimg = difference(border:(height-border),border:(width-border));
YCxCzLabDeltaE = sqrt(mean(mean(truncatedimg)));

