function img = sRGB2XYZ(img)

exact = 1;

% Reformat image for linear color transformations
[height,width,Ncolors] = size(img);
img = permute(img,[3,1,2]);
img = reshape(img,Ncolors,height*width);

% Remove gamma correction
if exact==1
  img = img/255;
  img = max( (1/12.92)*img,((1/1.055)*(img+0.055)).^(2.4) );
else
  img = (img/255).^(2.2);
end

% Chromaticities (x,y,z) - Rec. 709 Primary System
R709=[0.64 0.33 0.03]';
G709=[0.30 0.60 0.10]';
B709=[0.15 0.06 0.79]';
                                                                                
% D65 white point with Y=1.0
wpD65=[0.3127 0.3290 0.3583]';
wpD65=wpD65/wpD65(2);
                                                                                
% Calculate transformation matrix from sRGB to XYZ
constants=inv([R709, G709, B709])*wpD65;      % correction constants
T=[R709, G709, B709]*diag(constants);

% Transform to XYZ coordinates
img = T*img;

% Put image back in standard format
img = reshape(img,Ncolors,height,width);
img = ipermute(img,[3,1,2]);

